修改打包IPK

上一节我们讲到WebOS Doctor中的rootfs实际上是一组预先安装好的包(ipk)的集合,那我们如何自己修改和打包ipk呢?这一节我们就来讲讲这个。

ipk文件实际上是用ar命令打包的一个归档包。没有数字签名的ipk中一般包含control.tar.gz、data.tar.gz和debian-binary这三个文件。

其中debian-binary里面是固定的。

control.tar.gz中包含了control、md5sums、preinst、postinst、prerm、postrm这几个文件,其中control是必须的,其它都是可选的。

data.tar.gz中包含了要安装的程序和数据。

ipk的安装对于大多数用户来说都是使用preware、WebOS Quick Install、Internalz Pro来安装程序的。如果不考虑postinst脚本,那么使用这些工具安装的文件都是相对于/media/cryptofs/apps目录进行安装的。如果直接使用不带-o参数的ipkg install命令安装的话,那么安装的文件都是相对于/目录的。也就是说ipk包中实际上并不包含相对于那个路径进行安装的信息。安装到哪儿只跟安装的方式有关。

rootfs.tar.gz中那些预先安装好的包都是相对于/目录安装的。相对于/目录安装的程序,用户通过preware、WebOS Quick Install和系统自带的软件包管理器都是无法卸载的,但并不是说就真的无法卸载,实际上只要你愿意,这些包都可以在root帐号下用ipkg remove命令来卸载掉。

我们在上一节中有一个<carrier>.tar没有介绍(<carrier>表示att、wr、verizon等),之所以没介绍主要原因就是我们需要先了解上面的这些内容,然后才比较容易解释这个<carrier>.tar。

这个<carrier>.tar中的主要内容就是一些ipk包,另外,还有一个installer.xml。这个installer.xml如果不是要做跨运营商或跨机型移植,是不需要修改的。那么剩下的就是运营商定制的一些ipk包了。这些包是在刷机程序把rootfs.tar.gz写入设备之后,进行安装的。他们都是相对于/目录进行安装的。因此这些包从本质上来讲,跟rootfs.tar.gz中预先安装的包是没有区别的。唯一的区别就是rootfs.tar.gz中的包是预先安装好的,<carrier>.tar中的包是在刷机过程中进行安装的。而ROM验证md5sums的过程是在<carrier>.tar中的所有ipk安装之后才进行的。因此,<carrier>.tar中的包也是需要进行md5sums验证的。

既然<carrier>.tar中的包也需要验证,所以对于放在<carrier>.tar中的包来说,它的control.tar.gz中的md5sums不是可选的,而是必须的。如果缺少了这个md5sums,那么刷机到82%时,同样会因为无法通过md5sums验证而终止刷机,无法重启。

要生成一个带md5sums的ipk,如果靠手工来计算编写md5sums,并自己通过tar、gzip、ar等命令来打包实在是麻烦的很。实际上前人早在10年前就做好了这样的打包脚本,叫ipkg-build。我们可以直接拿来用。

下面是这个脚本的完整内容:

  1. #!/bin/sh  
  2.   
  3. # ipkg-build -- construct a .ipk from a directory  
  4. # Carl Worth <cworth@east.isi.edu>  
  5. # based on a script by Steve Redler IV, steve@sr-tech.com 5-21-2001  
  6. set -e  
  7.   
  8. ipkg_extract_value() {  
  9.     sed -e "s/^[^:]*:[[:space:]]*//"  
  10. }  
  11.   
  12. required_field() {  
  13.     field=$1  
  14.   
  15.     value=`grep "^$field:" < $CONTROL/control | ipkg_extract_value`  
  16.     if [ -z "$value" ]; then  
  17.         echo "*** Error: $CONTROL/control is missing field $field" >&2  
  18.         return 1  
  19.     fi  
  20.     echo $value  
  21.     return 0  
  22. }  
  23.   
  24. pkg_appears_sane() {  
  25.     local pkg_dir=$1  
  26.   
  27.     local owd=`pwd`  
  28.     cd $pkg_dir  
  29.   
  30.     PKG_ERROR=0  
  31.   
  32.     large_uid_files=`find . -uid +99`  
  33.     if [ -n "$large_uid_files" ]; then  
  34.         echo "*** Warning: The following files have a UID greater than 99.  
  35. You probably want to chown these to a system user: " >&2  
  36.         ls -ld $large_uid_files  
  37.         echo >&2  
  38.     fi  
  39.           
  40.   
  41.     if [ ! -f "$CONTROL/control" ]; then  
  42.         echo "*** Error: Control file $pkg_dir/$CONTROL/control not found." >&2  
  43.         cd $owd  
  44.         return 1  
  45.     fi  
  46.   
  47.     pkg=`required_field Package`  
  48.     [ "$?" -ne 0 ] && PKG_ERROR=1  
  49.   
  50.     version=`required_field Version | sed 's/.*://;'`  
  51.     [ "$?" -ne 0 ] && PKG_ERROR=1  
  52.   
  53.     arch=`required_field Architecture`  
  54.     [ "$?" -ne 0 ] && PKG_ERROR=1  
  55.   
  56.     required_field Maintainer >/dev/null  
  57.     [ "$?" -ne 0 ] && PKG_ERROR=1  
  58.   
  59.     required_field Description >/dev/null  
  60.     [ "$?" -ne 0 ] && PKG_ERROR=1  
  61.   
  62.     section=`required_field Section`  
  63.     [ "$?" -ne 0 ] && PKG_ERROR=1  
  64.     if [ -z "$section" ]; then  
  65.         echo "The Section field should have one of the following values:" >&2  
  66.         echo "Games, Multimedia, Communications, Settings, Utilies, Applications, Console, Misc" >&2  
  67.     fi  
  68.   
  69.     priority=`required_field Priority`  
  70.     [ "$?" -ne 0 ] && PKG_ERROR=1  
  71.     if [ -z "$priority" ]; then  
  72.         echo "The Priority field should have one of the following values:" >&2  
  73.         echo "required, important, standard, optional, extra." >&2  
  74.         echo "If you don't know which priority value you should be using, then use \`optional'" >&2  
  75.     fi  
  76.   
  77.     if echo $pkg | grep '[^a-z0-9.+-]'; then  
  78.         echo "*** Error: Package name $name contains illegal characters, (other than [a-z0-9.+-])" >&2  
  79.         PKG_ERROR=1;  
  80.     fi  
  81.   
  82.     local bad_fields=`sed -ne 's/^\([^[:space:]][^:[:space:]]\+[[:space:]]\+\)[^:].*/\1/p' < $CONTROL/control | sed -e 's/\\n//'`  
  83.     if [ -n "$bad_fields" ]; then  
  84.         bad_fields=`echo $bad_fields`  
  85.         echo "*** Error: The following fields in $CONTROL/control are missing a ':'" >&2  
  86.         echo "  $bad_fields" >&2  
  87.         echo "ipkg-build: This may be due to a missing initial space for a multi-line field value" >&2  
  88.         PKG_ERROR=1  
  89.     fi  
  90.   
  91.     for script in $CONTROL/preinst $CONTROL/postinst $CONTROL/prerm $CONTROL/postrm; do  
  92.         if [ -f $script -a ! -x $script ]; then  
  93.             echo "*** Error: package script $script is not executable" >&2  
  94.             PKG_ERROR=1  
  95.         fi  
  96.     done  
  97.   
  98.     if [ -f $CONTROL/conffiles ]; then  
  99.         for cf in `cat $CONTROL/conffiles`; do  
  100.             if [ ! -f ./$cf ]; then  
  101.                 echo "*** Error: $CONTROL/conffiles mentions conffile $cf which does not exist" >&2  
  102.                 PKG_ERROR=1  
  103.             fi  
  104.         done  
  105.     fi  
  106.   
  107.     cd $owd  
  108.     return $PKG_ERROR  
  109. }  
  110.   
  111. ###  
  112. # ipkg-build "main"  
  113. ###  
  114.   
  115. case $# in  
  116. 1)  
  117.     dest_dir=.  
  118.     ;;  
  119. 2)  
  120.     dest_dir=$2  
  121.     ;;  
  122. *)  
  123.     echo "Usage: ipkg-build <pkg_directory> [<destination_directory>]" >&2  
  124.     exit 1   
  125.     ;;  
  126. esac  
  127.   
  128. pkg_dir=$1  
  129.   
  130. if [ ! -d $pkg_dir ]; then  
  131.     echo "*** Error: Directory $pkg_dir does not exist" >&2  
  132.     exit 1  
  133. fi  
  134.   
  135. # CONTROL is second so that it takes precedence  
  136. CONTROL=  
  137. [ -d $pkg_dir/DEBIAN ] && CONTROL=DEBIAN  
  138. [ -d $pkg_dir/CONTROL ] && CONTROL=CONTROL  
  139. if [ -z "$CONTROL" ]; then  
  140.     echo "*** Error: Directory $pkg_dir has no CONTROL subdirectory." >&2  
  141.     exit 1  
  142. fi  
  143.   
  144. if ! pkg_appears_sane $pkg_dir; then  
  145.     echo >&2  
  146.     echo "ipkg-build: Please fix the above errors and try again." >&2  
  147.     exit 1  
  148. fi  
  149.   
  150. tmp_dir=$dest_dir/IPKG_BUILD.$$  
  151. mkdir $tmp_dir  
  152.   
  153. (cd $pkg_dir/data; find . -type f -print0 | xargs -0 md5sum ) > $pkg_dir/$CONTROL/md5sums  
  154. if [ ! -f "$pkg_dir/files.txt" ]; then  
  155.   (cd $pkg_dir/data; find . -type f -print0 |xargs -0 grep '' -l) >$pkg_dir/files.txt  
  156. fi  
  157. # tar -C $pkg_dir/data -cf $tmp_dir/data.tar -T $pkg_dir/files.txt -h --verify  
  158. tar -C $pkg_dir/data -cf $tmp_dir/data.tar . --verify  
  159. gzip -f $tmp_dir/data.tar  
  160. tar -C $pkg_dir/$CONTROL -czf $tmp_dir/control.tar.gz .  
  161.   
  162. echo "2.0" > $tmp_dir/debian-binary  
  163.   
  164. pkg_file=$dest_dir/${pkg}_${version}_${arch}.ipk  
  165. #tar -C $tmp_dir -czf $pkg_file ./debian-binary ./data.tar.gz ./control.tar.gz  
  166. (cd $tmp_dir ;ar -qc $pkg_file ./debian-binary ./data.tar.gz ./control.tar.gz ; mv $pkg_file ../)  
  167. rm $tmp_dir/debian-binary $tmp_dir/data.tar.gz $tmp_dir/control.tar.gz  
  168. rmdir $tmp_dir  
  169.   
  170. echo "Packaged contents of $pkg_dir into $pkg_file"  

这个脚本我对它作过一处非常细微的修改,旧的脚本中在打包data.tar.gz时,对软连接和硬连接是将连接指向的文件进行打包的。而实际上我们没有必要这样做,我们可以直接将连接以原始方式打包到ipk的data.tar.gz中,这是ipk包允许的。而且实际上webOS系统中原本有好多包本来就是带有软连接的,如果不做这个修改,后面我们就不能正确的将系统全部打包回ipk。

好了,有了这个脚本,我们就可以自制ipk包了。首先建立一个包的目录,通常我们以包名来命名,然后在其下建立两个目录,分别为CONTROL和data,注意大小写。

CONTROL目录下放control.tar.gz解压之后的内容。其中不必包含md5sums,即使包含在打包时也会重新生成,因此不必担心md5sums的正确性。

data目录下放data.tar.gz解压之后的内容。注意它是相对于/的,里面的内容要包含相对于/的路径。另外,即使你希望这些内容被安装到/media/cryptofs/apps,也不要把这个路径建立到data目录下,这个路径是在安装时才决定的。

之后你可以对这两个目录下的内容进行修改编辑,添加删除内容都可以。修改完毕之后,退回到这个包目录的上级目录下,然后将其拥有者和用户组都改为root(对于普通包是这样的,对于系统包来说,我们应该在解压系统包时就保留系统包的用户组,在修改时不要变更原来文件的用户组)。最后执行ipkg-build 包名,就可以重新打包生成修改之后的ipk了。

上文中提到的ipkg-build可在此直接下载:ipkg-build

标签: Palm, HP, WebOS, ROM

« 上一篇 | 下一篇 »

只显示10条记录相关文章

发表评论

评论 (必须):